routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes([
  'register' => false, // Registration Routes...
  'reset' => false, // Password Reset Routes...
  'verify' => false, // Email Verification Routes...
]);

Route::group(['middleware' => ['auth']], function() {
    Route::resource('roles','RoleController');
    Route::resource('users','UserController');
    Route::resource('projects','ProjectController');
    Route::resource('tasks','TaskController');
    Route::resource('comments','CommentController');
    Route::resource('logworks','LogworkController');
    
    ROute::get('changestatusproject/{id}/{pid}','ProjectController@changeStatus');
    Route::get('logworkremoved/{id}','LogworkController@is_removed');
    Route::get('download-logworks/{name}','LogworkController@download');
    Route::get('commentremoved/{id}','CommentController@is_removed');
    Route::get('download-comments/{name}','CommentController@download');
    Route::get('create-task/{id}','TaskController@createTicket');
    Route::get('task/{id}','TaskController@index');
    Route::get('download-attachemnt/{name}','TaskController@download');
});

Route::get('/home', 'HomeController@index')->name('home');
Route::resource('yourwork','YourworkController');
Route::get('projectExcel','ProjectController@excel');
Route::get('userBlock/{id}','UserController@userBlock');
Route::get('editUser/{id}','UserController@editUser');
Route::put('updateUser/{id}','UserController@updateUser');
Route::get('changePassword/{id}','UserController@changePassword');
Route::put('updatePassword/{id}','UserController@updatePassword');
Route::resource('logs','LogController');
Route::get('download/{filename}', 'LogController@getDownload');
// LocalizationController
Route::get('lang/{locale}', 'LocalizationController@index');
// ROUTE for getImage from photos folder
Route::get('/photos/{filename}', function ($filename)
{
    $path = storage_path() . '/photos/' . $filename;
    if(!File::exists($path)) abort(404);
    $file = File::get($path);
    $type = File::mimeType($path);
    $response = Response::make($file, 200);
    $response->header("Content-Type", $type);
    return $response;
})->name('photo');

app/Task.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use DB;

class Task extends Model
{
    protected $fillable = [
        'name', 'description'
    ];
    
    public function files()
    {
        return $this->belongsToMany('App\File');
    }

    public function creator()
    {
        return $this->belongsTo('App\User','user_id');
    }

    public function getFileDownload($id)
    {
        $file = DB::table('tasks')
        ->join('attachments','tasks.id','=','attachments.attachment_id')
        ->select('attachments.name')
        ->where('tasks.id','=',$id)
        ->where('attachments.type','tasks')
        ->get();
        return $file;
    }

}

app/Http/Controllers/TaskController.php
<?php

namespace App\Http\Controllers;

use Auth;
use App\Task;
use App\Project;
use App\User;
use App\Comment;
use App\Logwork;
use App\ProjectUser;
use App\Attachment;
use Illuminate\Http\Request;
use DB;
use App\LogActivity;
use Illuminate\Support\Facades\Storage;
use File;

class TaskController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $project = Project::find($project['id']);

        $tasks = DB::table('tasks')
        ->select('*')
        ->where('project_id',$project['id'])
        ->get();
        
        $users = $project->users()
			->orderBy('name', 'asc')
			->get();

        return view('projects.show',compact('users','project','tasks'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('tasks.create');
    }

    public function createTicket($id)
    {   
        return view('tasks.create',compact('id'));
    }
    /**
     * Store a newly creat0;ed resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'ticket' => 'required',
            'version' => 'required',
            'description' => 'required',
        ]);

        $input = $request->all();

        $ticket= new Task();
            $ticket->task= $input['ticket'];
            $ticket->project_id= $input['project_id'];
            $ticket->user_id= $input['user_id'];
            $ticket->description= $input['description'];
            $ticket->estimate= $input['estimate'];
            $ticket->version= $input['version'];
            $ticket->status= "0";
            $ticket->created_by = $input['created_by'];
        $ticket->save();

        $data[] = "";
       
        if($request->hasfile('file'))
         {
            foreach($request->file('file') as $file)
            {
                $name=date('YmdHis').'_'.rand() . '.' .$file->getClientOriginalName();
                //$file->move(storage_path().'/uploads/files/', $name);    
                $file->storeAs('uploads/tasks/', $name);
                //$data[] = $name;
                $attachment= new Attachment();
                $attachment->type = 'tasks';
                $attachment->attachment_id =$ticket->id;
                $attachment->name=$name;
                $attachment->path= 'N/A';  
                $attachment->save();
            }
        }
        
        
        \LogActivity::addToLog('Task',Auth::User()->id,Auth::User()->name,'Create', $input['ticket'].': '.$input['description']);

        $notification = array(
            'message' => 'Task has been created successfully.', 
            'title' => 'Message',
            'alert-type' => 'success',
            'alert' => 'toast-primary'
        );

        return redirect()->back()->with($notification); 
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Task  $ticket
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {   
        $tickets = Task::find($id);

        $comments = DB::table('comments')
            ->join('users','comments.user_id','=','users.id')
            ->join('attachments','comments.id','=','attachments.attachment_id')
            ->join('tasks','comments.task_id','=','tasks.id')
            ->select('*','comments.user_id as user_id','users.name as name','comments.id as comment_id','attachments.id as file_id','attachments.name as comment_image','attachments.type')
            ->where('comments.task_id','=',$id)
            ->where('attachments.type','comments')
            ->where('comments.is_removed','=',0)
            ->get();

        $logworks = DB::table('logworks')
            ->join('users','users.id','=','logworks.user_id')
            ->join('attachments','attachments.attachment_id','=','logworks.id')
            ->join('tasks','logworks.task_id','=','tasks.id')
            ->select('*','users.name as username','logworks.id as logwork_id','attachments.id as file_id','attachments.name as logwork_image','attachments.type')          
            ->where('logworks.task_id','=',$id)
            ->where('attachments.type','logworks')
            ->where('logworks.is_removed','=',0)
            ->get();
        
        $tracking_time = DB::table("logworks")
            ->leftjoin('tasks','tasks.id','=','logworks.id')
            ->select(DB::raw("SUM(logworks.time_spent) as tracking_time"))
            ->where('logworks.task_id',$id)
            ->first()->tracking_time;
            
        $estimate_time = DB::table("tasks")
            ->select(DB::raw("SUM(estimate) as estimate_time"))
            ->where('id',$id)
            ->first()->estimate_time;
               
        $remaining_time = $estimate_time - $tracking_time;

        $data = array(
            "tracking_time" => $tracking_time,
            "estimate_time" => $estimate_time,
            "remaining_time" => $remaining_time
        );

        $notification = array(
            'message' => 'Task has been created successfully.', 
            'alert-type' => 'success',
        );
        return view('tasks.show',compact('tickets','comments','logworks','data'))->with($notification);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Ticket  $ticket
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $task = Task::find($id);
        return view('tasks.edit',compact('task'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Task  $ticket
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $this->validate($request, [
            'ticket' => 'required',
            'version' => 'required',
            'description' => 'required',
        ]);

        $input = $request->all();
        
        $ticket= Task::find($id);
            $ticket->task= $input['ticket'];
            $ticket->estimate= $input['estimate'];
            $ticket->description= $input['description'];
            $ticket->version= $input['version'];
        $ticket->save();

        $tickets = Task::find($id);

        // if($request->hasfile('filename'))
        //  {
        //     // foreach($request->file('filename') as $file)
        //     // {
        //         $file = $request->file('filename');
        //         $name=date('YmdHis').'_'.rand() . '.' .$file->getClientOriginalName();
        //         //$file->move(storage_path().'/uploads/files/', $name);   
        //         $request->file('filename')->storeAs('uploads/files/', $name);
        //     //}
        //     $file= Attachment::where('attachment_id',$id)->update('name',$name);
        //     $file->save();
        //  }

        $data[] = "";
        if($request->hasfile('file'))
         {
            Attachment::where('attachment_id',$id)->delete();
            foreach($request->file('file') as $file)
            {
                $name=date('YmdHis').'_'.rand() . '.' .$file->getClientOriginalName();
                //$file->move(storage_path().'/uploads/files/', $name);    
                $file->storeAs('uploads/tasks/', $name);
                $attachment= new Attachment();
                $attachment->type = 'tasks';
                $attachment->attachment_id =$ticket->id;
                $attachment->name=$name;
                $attachment->path= 'N/A';  
                $attachment->save();
            }
            
        }

        $comments = DB::table('comments')
            ->join('users','comments.user_id','=','users.id')
            ->join('attachments','comments.id','=','attachments.attachment_id')
            ->join('tasks','comments.task_id','=','tasks.id')
            ->select('*','comments.user_id as user_id','users.name as name','comments.id as comment_id','attachments.id as file_id','attachments.name as comment_image')
            ->where('comments.task_id','=',$id)
            ->where('attachments.type','comment')
            ->where('comments.is_removed','=',0)
            ->get();

        $logworks = DB::table('logworks')
            ->join('users','users.id','=','logworks.user_id')
            ->join('attachments','attachments.attachment_id','=','logworks.id')
            ->join('tasks','logworks.task_id','=','tasks.id')
            ->select('*','logworks.id as logwork_id','attachments.id as file_id','attachments.name as logwork_image')          
            ->where('logworks.task_id','=',$id)
            ->where('attachments.type','logwork')
            ->where('logworks.is_removed','=',0)
            ->get();

        \LogActivity::addToLog('Task',Auth::User()->id,Auth::User()->name,'Update', $input['ticket'].': '.$input['description']);

        $notification = array(
            'message' => 'Task has been updated successfully.', 
            'alert-type' => 'success',
        );
        
        return view('tasks.show',compact('tickets','comments','logworks'))->with($notification);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Task  $ticket
     * @return \Illuminate\Http\Response
     */
    public function destroy(Ticket $ticket)
    {
        //
    }

    public function download($name){
        $path = storage_path('app/uploads/tasks/').$name;
        if(file_exists($path)){
            return response()->download($path);
        }else{
            return abort(404);
        }
    }
}

resources/views/tasks/create.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.task')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('projects.show',$id) }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_list_project')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <strong>Whoops!</strong> There were some problems with your input.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif   
            @if(session('success'))
            <div class="alert alert-success">
            {{ session('success') }}
            </div> 
            @endif         
            <div class="card">
                <div class="card-body table-responsive">
                    <form role="form" action="{{ route('tasks.store') }}" method="POST" enctype="multipart/form-data">
                        {{csrf_field()}}
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.task')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="ticket" class="form-control form-control-sm" placeholder="Enter task" value="{{ old('ticket') }}">
                                </div>
                            </div>                            
                        </div>
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.version')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="version" class="form-control form-control-sm" placeholder="Enter version" value="{{ old('version') }}">
                                </div>
                            </div>                            
                        </div>
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.estimate_time')}}<i class="text-red">* (h)</i></strong>
                                    <input type="number" name="estimate" class="form-control form-control-sm" placeholder="Enter estimate 1h" value="{{ old('estimate') }}">
                                </div>
                            </div>                            
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <strong>{{ __('veacha.description')}} <i class="text-red">*</i></strong>
                                    <textarea class="form-control form-control-sm textarea" name="description" rows="10" placeholder="Place some text here">{{ old('description') }}</textarea>
                                    
                                </div>
                            </div>
                        </div>
                        
                        <div class="row">
                            <div class="col-6 col-sm-6 col-xl-6">
                                <strong>{{ __('veacha.attachment_files')}} <i class="text-red">*</i></strong>
                                <div class="input-group control-group increment" >
                                <input type="file" name="file[]" class="form-control form-control-sm" style="height: 36px;">
                                <div class="input-group-btn" style="margin-top: 5px;"> 
                                    <button class="btn btn-primary btn-add-files btn-sm" type="button" style="height: 35px; margin-left:10px;"><i class="fas fa-plus-circle"></i> {{ __('veacha.add_file')}}</button>
                                </div>
                                </div>
                                <div class="clone hide">
                                <div class="control-group input-group" style="margin-top:10px">
                                    <input type="file" name="file[]" class="form-control form-control-sm" style="height: 36px;">
                                    <div class="input-group-btn" style="margin-top: 5px;"> 
                                    <button class="btn btn-danger btn-sm" type="button" style="height: 35px; margin-left:10px;"><i class="fas fa-trash"></i> {{ __('veacha.remove_file')}}</button>
                                    </div>
                                </div>
                                </div>
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <input type="hidden" name="user_id" value="{{ Auth::user()->id }}">
                                    <input type="hidden" name="created_by" value="{{ Auth::user()->name }}">
                                    <input type="hidden" name="project_id" value="{{ $id }}">
                                    <button type="submit" class="btn btn-primary">{{ __('veacha.button_save_task')}}</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('js')
    <script>
        $(document).ready(function() {
$(".clone").hide();
      $(".btn-add-files").click(function(){ 
          var html = $(".clone").html();
          $(".increment").after(html);
      });

      $("body").on("click",".btn-danger",function(){ 
          $(this).parents(".control-group").remove();
      });

    });
    </script>
    @include('notification')
@endsection

resources/views/tasks/edit.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.task')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('tasks.show',$task->id ) }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_list_project')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <strong>Whoops!</strong> There were some problems with your input.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif   
            @if(session('success'))
            <div class="alert alert-success">
            {{ session('success') }}
            </div> 
            @endif         
            <div class="card">
                <div class="card-body table-responsive">
                    <form role="form" action="{{ route('tasks.update',$task->id) }}" method="POST" enctype="multipart/form-data">
                        {{ csrf_field() }}
                        {{ method_field('PATCH') }}
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.task')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="ticket" class="form-control form-control-sm" placeholder="Enter ticket" value="{{ $task->task }}">
                                </div>
                            </div>                            
                        </div>
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.version')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="version" class="form-control form-control-sm" placeholder="Enter version" value="{{ $task->version }}">
                                </div>
                            </div>                            
                        </div>
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.estimate_time') }}<i class="text-red">* (h)</i></strong>
                                    <input type="number" name="estimate" class="form-control form-control-sm" placeholder="Enter estimate 1h" value="{{ $task->estimate }}">
                                </div>
                            </div>                            
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <strong>{{ __('veacha.description')}} <i class="text-red">*</i></strong>
                                    <textarea class="form-control form-control-sm textarea" name="description" rows="10" placeholder="Place some text here">{{ $task->description }}</textarea>
                                    
                                </div>
                            </div>
                        </div>
                        
                        <div class="row">
                            <div class="col-6 col-sm-6 col-xl-6">
                                <strong>{{ __('veacha.attachment_files')}} <i class="text-red">*</i></strong>
                                <div class="input-group control-group increment" >
                                <input type="file" name="file[]" class="form-control form-control-sm" style="height: 36px;">
                                <div class="input-group-btn" style="margin-top: 5px;"> 
                                    <button class="btn btn-primary btn-add-files btn-sm" type="button" style="height: 35px; margin-left:10px;"><i class="fas fa-plus-circle"></i> {{ __('veacha.add_file')}}</button>
                                </div>
                                </div>
                                <div class="clone hide">
                                <div class="control-group input-group" style="margin-top:10px">
                                    <input type="file" name="file[]" class="form-control form-control-sm" style="height: 36px;">
                                    <div class="input-group-btn" style="margin-top: 5px;"> 
                                    <button class="btn btn-danger btn-sm" type="button" style="height: 35px; margin-left:10px;"><i class="fas fa-trash"></i> {{ __('veacha.remove_file')}}</button>
                                    </div>
                                </div>
                                </div>
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <button type="submit" class="btn btn-primary">{{ __('veacha.button_update_task')}}</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('js')
    <script>
        $(document).ready(function() {
    $(".clone").hide();
      $(".btn-add-files").click(function(){ 
          var html = $(".clone").html();
          $(".increment").after(html);
      });

      $("body").on("click",".btn-danger",function(){ 
          $(this).parents(".control-group").remove();
      });

    });
    </script>
    @include('notification')
@endsection